package com.cmc.agent.controller;

import com.google.gson.Gson;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import okhttp3.*;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * cmc知识库Controller
 * 
 * @author cmc
 * @date 2025-04-08
 */
@RestController
@RequestMapping("/llm/session")
public class SessionController extends BaseController
{
    /**
     * 生成回答
     */
    @PostMapping("/answer")
    public AjaxResult answer(String question) throws IOException {

        // 1. 调用本地LLM或HTTP服务
        return success(generateAnswer(question));
    }

    // 调用LLM生成回答
    public String generateAnswer(String question) throws IOException {
        Gson gson = new Gson();
        Map<String, String> hashMap = new HashMap<>();
        hashMap.put("prompt", question);
        hashMap.put("max_tokens", "512");
        RequestBody body = RequestBody.create(
                MediaType.parse("application/json"),
                new Gson().toJson(hashMap));

        Request request = new Request.Builder()
                .url("http://192.168.28.188:8080/generate")
                .post(body)
                .build();

        try (Response response = new OkHttpClient().newCall(request).execute()) {
            return gson.fromJson(response.body().string(), Map.class).get("generated_text").toString();
        }
    }

}
